<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2010 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: shoutbox_admin.php
| CVS Version: 1.00
| Author: Matias Casas (PhAnToM) for
| PHP-Fusion Argentina - www.php-fusion.com.ar
+--------------------------------------------------------+
| LOA Shoutbox Center panel was inspired by Shoutbox from 
| Fangree Productions - www.fangree.co.uk
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
require_once "../../maincore.php";
require_once THEMES."templates/admin_header.php";
include LOCALE.LOCALESET."admin/settings.php";

include INFUSIONS."shoutbox_center_panel/infusion_db.php";

if (!checkrights("SCP") || !defined("iAUTH") || $_GET['aid'] != iAUTH) { redirect("../index.php"); }

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."shoutbox_center_panel/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."shoutbox_center_panel/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."shoutbox_center_panel/locale/English.php";
}

if (isset($_GET['error']) && isnum($_GET['error']) && !isset($message)) {
	if ($_GET['error'] == 0) {
		$message = $locale['900'];
	} elseif ($_GET['error'] == 1) {
		$message = $locale['901'];
	}
	if (isset($message)) {
		echo "<div id='close-message'><div class='admin-message'>".$message."</div></div>\n"; 
	}
}

if (isset($_POST['savesettings'])) {
	$error = 0;
	$scp_message = descript(stripslash($_POST['scp_message']));
	
	$result = dbquery("UPDATE ".DB_SHOUTBOXCP_SETTINGS." SET scp_status='".(isnum($_POST['scp_status']) ? $_POST['scp_status'] : "0")."'");
	if (!$result) { $error = 1; }
	$result = dbquery("UPDATE ".DB_SHOUTBOXCP_SETTINGS." SET scp_avatar='".(isnum($_POST['scp_avatar']) ? $_POST['scp_avatar'] : "0")."'");
	if (!$result) { $error = 1; }
	$result = dbquery("UPDATE ".DB_SHOUTBOXCP_SETTINGS." SET scp_avatar_url='".stripinput($_POST['scp_avatar_url'])."'");
	if (!$result) { $error = 1; }
	$result = dbquery("UPDATE ".DB_SHOUTBOXCP_SETTINGS." SET scp_message='".addslashes(addslashes($scp_message))."'");
	if (!$result) { $error = 1; }

	redirect(FUSION_SELF.$aidlink."&error=".$error);
}

$options = dbarray(dbquery("SELECT * FROM ".DB_SHOUTBOXCP_SETTINGS.""));

ob_start();
opentable($locale['400']);
echo "<form name='settingsform' method='post' action='".FUSION_SELF.$aidlink."'>\n";
echo "<table cellpadding='0' cellspacing='0' width='500' class='center'>\n<tr>\n";
echo "<td class='tbl2' align='center' colspan='2'>".$locale['scp_100']."</td>";
echo "</tr>\n<tr>\n";
echo "<td width='50%' class='tbl'>".$locale['scp_101']."<br /><span class='small2'>".$locale['scp_102']."</span></td>\n";
echo "<td width='50%' class='tbl'><select name='scp_status' class='textbox'>\n";
echo "<option value='1'".($options['scp_status'] == "1" ? " selected='selected'" : "").">".$locale['518']."</option>\n";
echo "<option value='0'".($options['scp_status'] == "0" ? " selected='selected'" : "").">".$locale['519']."</option>\n";
echo "</select></td>\n";
echo "</tr>\n<tr>\n";
echo "<td width='50%' class='tbl'>".$locale['scp_103']."<br /><span class='small2'>".$locale['scp_104']."</span></td>\n";
echo "<td width='50%' class='tbl'><select name='scp_avatar' class='textbox'>\n";
echo "<option value='1'".($options['scp_avatar'] == "1" ? " selected='selected'" : "").">".$locale['518']."</option>\n";
echo "<option value='0'".($options['scp_avatar'] == "0" ? " selected='selected'" : "").">".$locale['519']."</option>\n";
echo "</select></td>\n";
echo "</tr>\n<tr>\n";
echo "<td valign='top' class='tbl'>".$locale['scp_105']."<br /><span class='small2'>".$locale['scp_106']."</span></td>\n";
echo "<td width='50%' class='tbl'><input type='text' name='scp_avatar_url' value='".$options['scp_avatar_url']."' maxlength='255' class='textbox' style='width:230px;' /></td>\n";
echo "</tr>\n<tr>\n";
echo "<td valign='top' class='tbl'>".$locale['scp_107']."<br /><span class='small2'>".$locale['scp_108']."</span></td>\n";
echo "<td width='50%' class='tbl'><textarea name='scp_message' cols='50' rows='6' class='textbox' style='width:230px;'>".phpentities(stripslashes($options['scp_message']))."</textarea></td>\n";
echo "</tr>\n<tr>\n";
echo "<td align='center' colspan='2' class='tbl'><br />";
echo "<input type='submit' name='savesettings' value='".$locale['750']."' class='button' /></td>\n";
echo "</tr>\n</table>\n</form>\n";
closetable();

require_once THEMES."templates/footer.php";
?>