<?php
/*-------------------------------------------------------+
| PHP-Fusion Content Management System
| Copyright (C) 2002 - 2010 Nick Jones
| http://www.php-fusion.co.uk/
+--------------------------------------------------------+
| Filename: shoutbox_center_panel.php
| Author: Nick Jones (Digitanium)
| Modified: Matias Casas (PhAnToM) for
| PHP-Fusion Argentina - www.php-fusion.com.ar
+--------------------------------------------------------+
| LOA Shoutbox Center panel was inspired by Shoutbox from 
| Fangree Productions - www.fangree.co.uk
+--------------------------------------------------------+
| This program is released as free software under the
| Affero GPL license. You can redistribute it and/or
| modify it under the terms of this license which you
| can read by viewing the included agpl.txt or online
| at www.gnu.org/licenses/agpl.html. Removal of this
| copyright header is strictly prohibited without
| written permission from the original author(s).
+--------------------------------------------------------*/
if (!defined("IN_FUSION")) { die("Access Denied"); }
include INFUSIONS."shoutbox_panel/infusion_db.php";

// Check if locale file is available matching the current site locale setting.
if (file_exists(INFUSIONS."shoutbox_center_panel/locale/".$settings['locale'].".php")) {
	// Load the locale file matching the current site locale setting.
	include INFUSIONS."shoutbox_center_panel/locale/".$settings['locale'].".php";
} else {
	// Load the infusion's default locale file.
	include INFUSIONS."shoutbox_center_panel/locale/English.php";
}

$link = FUSION_SELF.(FUSION_QUERY ? "?".FUSION_QUERY : "");
$link = preg_replace("^(&amp;|\?)s_action=(edit|delete)&amp;shout_id=\d*^", "", $link);
$sep = stristr($link, "?") ? "&amp;" : "?";

if (iMEMBER && (isset($_GET['s_action']) && $_GET['s_action'] == "delete") && (isset($_GET['shout_id']) && isnum($_GET['shout_id']))) {
	if ((iADMIN && checkrights("S")) || (iMEMBER && dbcount("(shout_id)", DB_SHOUTBOX, "shout_id='".$_GET['shout_id']."' AND shout_name='".$userdata['user_id']."'"))) {
		$result = dbquery("DELETE FROM ".DB_SHOUTBOX." WHERE shout_id='".$_GET['shout_id']."'".(iADMIN ? "" : " AND shout_name='".$userdata['user_id']."'"));
	}
	redirect($link);
}

include_once INFUSIONS."shoutbox_center_panel/shoutbox_center_panel_includes.php";

function sbwrap($text) {
	global $locale;
	
	$i = 0; $tags = 0; $chars = 0; $res = "";
	
	$str_len = strlen($text);
	
	for ($i = 0; $i < $str_len; $i++) {
		$chr = mb_substr($text, $i, 1, $locale['charset']);
		if ($chr == "<") {
			if (mb_substr($text, ($i + 1), 6, $locale['charset']) == "a href" || mb_substr($text, ($i + 1), 3, $locale['charset']) == "img") {
				$chr = " ".$chr;
				$chars = 0;
			}
			$tags++;
		} elseif ($chr == "&") {
			if (mb_substr($text, ($i + 1), 5, $locale['charset']) == "quot;") {
				$chars = $chars - 5;
			} elseif (mb_substr($text, ($i + 1), 4, $locale['charset']) == "amp;" || mb_substr($text, ($i + 1), 4, $locale['charset']) == "#39;" || mb_substr($text, ($i + 1), 4, $locale['charset']) == "#92;") {
				$chars = $chars - 4;
			} elseif (mb_substr($text, ($i + 1), 3, $locale['charset']) == "lt;" || mb_substr($text, ($i + 1), 3, $locale['charset']) == "gt;") {
				$chars = $chars - 3;
			}
		} elseif ($chr == ">") {
			$tags--;
		} elseif ($chr == " ") {
			$chars = 0;
		} elseif (!$tags) {
			$chars++;
		}
		
		if (!$tags && $chars == 18) {
			$chr .= "<br />";
			$chars = 0;
		}
		$res .= $chr;
	}
	
	return $res;
}

openside($locale['scp_title']);
$numrows = dbcount("(shout_id)", DB_SHOUTBOX, "shout_hidden='0'");
$result = dbquery(
	"SELECT ts.shout_id, ts.shout_name, ts.shout_message, ts.shout_datestamp, tu.user_id, tu.user_name, tu.user_avatar, tu.user_lastvisit, tu.user_status
	FROM ".DB_SHOUTBOX." ts
	LEFT JOIN ".DB_USERS." tu ON ts.shout_name=tu.user_id
	WHERE shout_hidden='0'
	ORDER BY ts.shout_datestamp DESC LIMIT 0,"
);
if (dbrows($result)) {
	$i = 0;
	echo" <div class='tbl' style='height:200px; overflow:auto;'>";
	while ($data = dbarray($result)) {
		echo "<div class='shoutboxname'>";
		if ($data['user_name']) {
			/* AVATAR */
			if($scp_settings['scp_avatar']=='1') {
				if ($data['user_avatar'] && file_exists(IMAGES."avatars/".$data['user_avatar'])) {
					echo "<img src='".IMAGES."avatars/".$data['user_avatar']."' alt='".$locale['sb_av1']."' width='20px' height='20px' border='0' style='vertical-align:middle; opacity:0.6;filter:alpha(opacity=60)' onmouseover='this.style.opacity=1;this.filters.alpha.opacity=100' onmouseout='this.style.opacity=0.6;this.filters.alpha.opacity=60'''/>\n";
				} else {
					if($scp_settings['scp_avatar_url']!='') {
						echo "<img src='".stripslashes($scp_settings['scp_avatar_url'])."' alt='".$locale['sb_noav1']."' width='20px' height='20px' border='0' style='vertical-align:middle;/>";
					} else {
						echo "<img src='".INFUSIONS."shoutbox_center_panel/images/noav.gif' alt='".$locale['sb_noav1']."' width='20px' height='20px' border='0' style='vertical-align:middle;/>";
					}
				}
			}
			/* AVATAR */
			echo "<span class='side'>".profile_link($data['shout_name'], $data['user_name'], $data['user_status'])."</span>\n";
		} else {
			echo $data['shout_name']."\n";
		}
		/* ONLINE */
		if($scp_settings['scp_status']=='1') {
			if ($data['user_lastvisit']<(time()-60)) {
				echo " <img src='".INFUSIONS."shoutbox_center_panel/images/offline.gif' alt='".$data['user_name']." ".$locale['sb_off1']."' title='".$data['user_name']." ".$locale['sb_off1']."'  style='vertical-align:middle; border:0px;'/> \n";
			} else {
				echo " <img src='".INFUSIONS."shoutbox_center_panel/images/online.gif' alt='".$data['user_name']." ".$locale['sb_on1']."' title='".$data['user_name']." ".$locale['sb_on1']."'  style='vertical-align:middle; border:0px;' /> \n";
			}
		}
		/* ONLINE */
		echo "</div>\n";
		echo "<div class='shoutboxdate'>".showdate("shortdate", $data['shout_datestamp'])."</div>";
		echo "<div class='shoutbox'>".sbwrap(parseubb(parsesmileys($data['shout_message']), "b|i|u|url|color"))."</div>\n";
		if ((iADMIN && checkrights("S")) || (iMEMBER && $data['shout_name'] == $userdata['user_id'] && isset($data['user_name']))) {
			echo "[<a href='".$link.$sep."s_action=edit&amp;shout_id=".$data['shout_id']."#edit_shout"."' class='side'>".$locale['sb_006']."</a>]\n";
			echo "[<a href='".$link.$sep."s_action=delete&amp;shout_id=".$data['shout_id']."' class='side'>".$locale['sb_007']."</a>]<br />\n";
		}
		$i++;
		if ($i != $numrows) { echo "<br />\n"; }
	}
	echo "</div>\n";
	if ($numrows > $settings['numofshouts']) {
		echo "<div style='text-align:center'>\n<a href='".INFUSIONS."shoutbox_center_panel/shoutbox_archive.php' class='side'>".$locale['sb_005']."</a>\n</div>\n";
	}
} else {
	echo "<div>".$locale['sb_004']."</div>\n";
}

if (iMEMBER || $settings['guestposts'] == "1") {
	include_once INCLUDES."bbcode_include.php";
	if (isset($_POST['post_shout'])) {
		$flood = false;
		if (iMEMBER) {
			$shout_name = $userdata['user_id'];
		} elseif ($settings['guestposts'] == "1") {
			$shout_name = trim(stripinput($_POST['shout_name']));
			$shout_name = preg_replace("(^[0-9\s]*)", "", $shout_name);
			if (isnum($shout_name)) { $shout_name = ""; }
			include_once INCLUDES."securimage/securimage.php";
			$securimage = new Securimage();
			if (!isset($_POST['sb_captcha_code']) || $securimage->check($_POST['sb_captcha_code']) == false) { redirect($link); }
		}
		$shout_message = str_replace("\n", " ", $_POST['shout_message']);
		$shout_message = preg_replace("/^(.{255}).*$/", "$1", $shout_message);
		$shout_message = trim(stripinput(censorwords($shout_message)));
		if (iMEMBER && (isset($_GET['s_action']) && $_GET['s_action'] == "edit") && (isset($_GET['shout_id']) && isnum($_GET['shout_id']))) {
			$comment_updated = false;
			if ((iADMIN && checkrights("S")) || (iMEMBER && dbcount("(shout_id)", DB_SHOUTBOX, "shout_id='".$_GET['shout_id']."' AND shout_name='".$userdata['user_id']."'"))) {
				if ($shout_message) {
					$result = dbquery("UPDATE ".DB_SHOUTBOX." SET shout_message='$shout_message' WHERE shout_id='".$_GET['shout_id']."'".(iADMIN ? "" : " AND shout_name='".$userdata['user_id']."'"));
				}
			}
			redirect($link);
		} elseif ($shout_name && $shout_message) {
			require_once INCLUDES."flood_include.php";
			if (!flood_control("shout_datestamp", DB_SHOUTBOX, "shout_ip='".USER_IP."'")) {
				$result = dbquery("INSERT INTO ".DB_SHOUTBOX." (shout_name, shout_message, shout_datestamp, shout_ip, shout_hidden) VALUES ('$shout_name', '$shout_message', '".time()."', '".USER_IP."', '0')");
			}
		}
		redirect($link);
	}
	if (iMEMBER && (isset($_GET['s_action']) && $_GET['s_action'] == "edit") && (isset($_GET['shout_id']) && isnum($_GET['shout_id']))) {
		$esresult = dbquery(
			"SELECT ts.shout_id, ts.shout_name, ts.shout_message, tu.user_id, tu.user_name
			FROM ".DB_SHOUTBOX." ts
			LEFT JOIN ".DB_USERS." tu ON ts.shout_name=tu.user_id
			WHERE ts.shout_id='".$_GET['shout_id']."'"
		);
		if (dbrows($esresult)) {
			$esdata = dbarray($esresult);
			if ((iADMIN && checkrights("S")) || (iMEMBER && $esdata['shout_name'] == $userdata['user_id'] && isset($esdata['user_name']))) {
				if ((isset($_GET['s_action']) && $_GET['s_action'] == "edit") && (isset($_GET['shout_id']) && isnum($_GET['shout_id']))) {
					$edit_url = $sep."s_action=edit&amp;shout_id=".$esdata['shout_id'];
				} else {
					$edit_url = "";
				}
				$shout_link = $link.$edit_url;
				$shout_message = $esdata['shout_message'];
			}
		} else {
			$shout_link = $link;
			$shout_message = "";
		}
	} else {
		$shout_link = $link;
		$shout_message = "";
	}
	
	echo "<a id='edit_shout' name='edit_shout'></a>\n";
	echo "<form name='shout_form' method='post' action='".$shout_link."'>\n";
	echo "<div style='text-align:center'><hr width='95%'>";
	echo "<a title='dupa' href='javascript:void(0)' onClick=\"document.getElementById('shout').style.display = (document.getElementById('shout').style.display == 'none' ? 'block' : 'none');\"><img style='vertical-align:middle' src='".BASEDIR."infusions/shoutbox_center_panel/images/shout.png' title='dupa' alt='dupa' border='0' /> <strong>".$locale['sb_003']."</strong></a>";
	echo "<div style='display: none;' id='shout'>";
	/* MESSAGE */
	if($scp_settings['scp_message']!='') {
		echo "<div class='admin-message' style='text-align: center; margin:auto; width:366px; '><strong>".stripslashes($scp_settings['scp_message'])."</strong></div>";
	}
	/* MESSAGE */
	if (iGUEST) {
		echo $locale['global_151']."<br />\n";
		echo "<input type='text' name='shout_name' value='' class='textbox' maxlength='30' style='width:140px' /><br />\n";
		echo $locale['global_152']."<br />\n";
	}
	echo "<fieldset><legend>Shout:</legend>";
	echo "<textarea name='shout_message' rows='2' cols='20' class='textbox' style='width:368px'>".$shout_message."</textarea><br />\n";
	echo "<span class='counterb'>".$locale['sb_count1']."</span> <span class='counter' ></span> <span class='counterb'>".$locale['sb_count2']."</span>\n";
	echo "</fieldset>\n<br />";
	echo "<div style='text-align:center'>".display_bbcodes("100%", "shout_message", "shout_form", "smiley|b|i|u|url|color")."</div>\n";
	if (iGUEST) {
		echo $locale['global_158']."<br />\n";
		echo "<img id='sb_captcha' src='".INCLUDES."securimage/securimage_show.php' alt='' /><br />\n";
    echo "<a href='".INCLUDES."securimage/securimage_play.php'><img src='".INCLUDES."securimage/images/audio_icon.gif' alt='' class='tbl-border' style='margin-bottom:1px' /></a>\n";
    echo "<a href='#' onclick=\"document.getElementById('sb_captcha').src = '".INCLUDES."securimage/securimage_show.php?sid=' + Math.random(); return false\"><img src='".INCLUDES."securimage/images/refresh.gif' alt='' class='tbl-border' /></a><br />\n";
		echo $locale['global_159']."<br />\n<input type='text' name='sb_captcha_code' class='textbox' style='width:100px' /><br />\n";
	}
	echo "<br /><input type='submit' name='post_shout' value='".$locale['sb_003']."' class='button' />\n";
	echo "</div>\n</div>\n</form>\n<br />\n";
} else {
	echo "<div style='text-align:center'>".$locale['global_154']."</div><br />\n";
}

closeside();
?>
